routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\DB;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
use App\Http\Controllers\UserController;


Route::middleware(['auth:sanctum', 'verified'])->group(function () {
    Route::get('/', function () {
        $result = DB::select(DB::raw('SELECT table_name AS "Table",
        ((data_length + index_length) / 1024/1024) AS "Size"
        FROM information_schema.TABLES
        WHERE table_schema ="'.getenv("DB_DATABASE"). '"
        ORDER BY (data_length + index_length) DESC'));
        $size = array_sum(array_column($result, 'Size'));
        $db_size = number_format((float)$size, 2, '.', '');
        
        return view('dashboard',[
            'db_size'=>$db_size
        ]);
    })->name("ovp_panel.dashboard");
    Route::get('settings', function () {
        return view('settings');
    })->name("ovp_panel.dashboard.settings");

    Route::get('logs', function () {
        return view('logs');
    })->name("ovp_panel.dashboard.logs");
    Route::resource('users', UserController::class,[
        'names'=>[
            'index'=>"ovp_panel.dashboard.users",
            'create'=>"ovp_panel.dashboard.users.create",
            'store'=>"ovp_panel.dashboard.users.store",
            'show'=>"ovp_panel.dashboard.users.show",
            'edit'=>"ovp_panel.dashboard.users.edit",
            'update'=>"ovp_panel.dashboard.users.update",
            'destroy'=>"ovp_panel.dashboard.users.destroy",
        ]
    ]);

});

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Fortify\TwoFactorAuthenticatable;
use Laravel\Jetstream\HasProfilePhoto;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens;
    use HasFactory;
    use HasProfilePhoto;
    use Notifiable;
    use TwoFactorAuthenticatable;

    /**
     * The attributes that are mass assignable.
     *
     * @var string[]
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
        'two_factor_recovery_codes',
        'two_factor_secret',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    /**
     * The accessors to append to the model's array form.
     *
     * @var array
     */
    protected $appends = [
        'profile_photo_url',
    ];
}

app/helpers.php
<?php 
function randomPassword() {
$alphabet = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890';
$pass = array(); //remember to declare $pass as an array
$alphaLength = strlen($alphabet) - 1; //put the length -1 in cache
for ($i = 0; $i < 8; $i++) { $n=rand(0, $alphaLength); $pass[]=$alphabet[$n]; } return implode($pass); 

}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\User;
use Illuminate\Support\Facades\Hash;
class UserController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('user.index', [
            'users' => User::all()
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('user.create', [
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
      
        $request->validate([
            'name' => 'required|string|max:255',
            'email' => 'required|string|email|max:255|unique:users',
            'password' => ['required'],
        ]);

        $user = User::create([
            'name' => $request->name,
            'email' => $request->email,
            'password' => Hash::make($request->password),
        ]);
        return redirect()->route('ovp_panel.dashboard.users');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        return view('user.edit', [
            'user' => User::findOrFail($id)
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {

        $user = User::findOrFail($id);
        $request->validate([
            'name' => 'required|string|max:255',
            'email' => 'required|string|email|max:255|unique:users,email,'.$user->id,
            'password' => [],
        ]);

        $user->name = $request->name;
        $user->email = $request->email;

        if($request->password){
            $user->password = Hash::make($request->password);
        }
        $user->save();
        return redirect()->route('ovp_panel.dashboard.users');

    }
    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $user = User::findOrFail($id);
        $user->delete();
        return redirect()->route('ovp_panel.dashboard.users')
                        ->with('success','User deleted successfully');
    }
}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.app');
    }
}

app/View/Components/GuestLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class GuestLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.guest');
    }
}

resources/views/layouts/admin.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Fonts -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Nunito:wght@400;600;700&display=swap">

    <!-- Styles -->
    <link rel="stylesheet" href="{{ mix('css/app.css') }}">

    @livewireStyles

    <!-- Scripts -->
    <script src="{{ mix('js/app.js') }}" defer></script>
</head>

<body class="font-sans antialiased">
    <x-jet-banner />

    <div class="min-h-screen bg-gray-100">
        @livewire('navigation-menu')

        <!-- Page Heading -->
        @if (isset($header))
        <header class="bg-white shadow">
            <div class="max-w-7xl mx-auto py-6 px-4 sm:px-6 lg:px-8">
                {{ $header }}
            </div>
        </header>
        @endif

        <!-- Page Content -->
        <main>
            {{ $slot }}
        </main>
    </div>

    @stack('modals')

    @livewireScripts
</body>

</html>

resources/views/layouts/guest.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="csrf-token" content="{{ csrf_token() }}">

        <title>{{ config('app.name', 'Laravel') }}</title>

        <!-- Fonts -->
        <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Nunito:wght@400;600;700&display=swap">

        <!-- Styles -->
        <link rel="stylesheet" href="{{ asset('css/app.css') }}">

        <!-- Scripts -->
        <script src="{{ mix('js/app.js') }}" defer></script>
    </head>
    <body>
        <div class="font-sans text-gray-900 antialiased">
            {{ $slot }}
        </div>
    </body>
</html>

resources/views/logs.blade.php
 <?php
                            $path1 = env("LOGPATH");
                            $path2 = env("LOGPATH");
                            ?>
                    <?php
                                function dir_size($directory,$path1) {
                                    $size = 0;
                                    if($directory==$path1."/."||$directory==$path1."/.."){
                                        return -1;
                                    }
                                    if(is_dir($directory)) {
                                        try {
                                            foreach(new RecursiveIteratorIterator(new RecursiveDirectoryIterator($directory)) as $file){
                                                if(is_file($file)){
                                                    $size += $file->getSize();
                                                }
                                            }
                                            return $size;

                                        } catch (\Throwable $th) {
                                            echo $th;
                                            return 0;
                                        }
                                    }
                                    else{
                                        return filesize($directory);
                                    }
                                }
                                function format_size($size) {
                                    if($size==-1){
                                        return "--";
                                    }
                                    $mod = 1024;
                                    $units = explode(' ','B KB MB GB TB PB');
                                    for ($i = 0; $size > $mod; $i++) {
                                        $size /= $mod;
                                    }
                                    return round($size, 2) . ' ' . $units[$i];
                                }

                                function listFolderFiles($dir,$path1,$withPercentage=false){
                                    $ignored = [];
                                    $files = array();
                                    foreach (scandir($dir) as $file) {
                                        if (in_array($file, $ignored)) continue;
                                        $files[$file] = filemtime($dir . '/' . $file);
                                    }
                                    arsort($files);
                                    $files = array_keys($files);

                                    $fileFolderList = $files;
                                    // $fileFolderList = scandir($dir);
                                    if(!$withPercentage){
                                        echo '<ul class="folder-target">';
                                        foreach($fileFolderList as $key=>$fileFolder){
                                            if($fileFolder != '.' && $fileFolder != '..'){
                                                if(!is_dir($dir.'/'.$fileFolder)){
                                                    $logs_api = env("LOGS_API")
                                                    ?>
                                                   <li onclick="selectFile('<?php echo $logs_api?>','<?php echo $key ?>')" class="file-log"><span class="file-name"><?php echo $fileFolder ?></span>
                                                    <?php
                                                } 
                                                echo '</li>';
                                            }
                                        }
                                        echo '</ul>';
                                    }
                                    else{
                                        $total_size = dir_size($path1,$path1);
                                        echo '<ul class="folder-target">';
                                        foreach($fileFolderList as $fileFolder){
                                            if($fileFolder != '.' && $fileFolder != '..'){
                                                $size = dir_size($dir.'/'.$fileFolder,$path1);
                                                $percentage = 0;
                                                if($total_size>0){
                                                    $percentage = ($size/$total_size)*100;
                                                }

                                                    echo 
                                                    '<li class="file-log">
                                                        <span class="file-name">'
                                                        .$fileFolder.'
                                                        </span>
                                                        <span class="bar-container">
                                                            <span style="width:'.$percentage.'%;" class="bar">
                                                            </span>
                                                        </span>
                                                    </li>';
                                            }
                                        }
                                        echo '</ul>';
                                    }
                                    
                                }
                            ?>
<x-app-layout active="logs" title="Logs">
<div class="content">
    <div class="container-fluid">
        <div class="row">
            <div class="col-lg-4">
                <div class="card">
                        <?php
                            $total_size = dir_size($path1,$path1);
                        ?>
                    <div class="card-header ui-sortable-handle">
                        <div class="d-flex justify-content-between">
                            <h3 class="card-title font-weight-bold">Files</h3>
                           
                        </div>
                    </div>
                    <div class="card-body px-0">
                        <?php
                            echo '<ul class="directories">';
                            listFolderFiles($path1,$path1);
                            echo '</ul>';

                        ?>
                    </div>
                </div>
            </div>
            <div class="col-lg-8">
            <div class="card">
                <div class="card-header ui-sortable-handle">
                    <div class="d-flex justify-content-between">
                        <h3 class="card-title font-weight-bold">Content</h3>
                    </div>
                </div>
                <div class="card-body px-0">
  
                    <ul class="file-content-result">
                                Please select a file to view its content.
                    </ul>
                </div>
                </div>
            </div>
        </div>
    </div>
</div>
</x-app-layout>

resources/views/policy.blade.php
<x-guest-layout>
    <div class="pt-4 bg-gray-100">
        <div class="min-h-screen flex flex-col items-center pt-6 sm:pt-0">
            <div>
                <x-jet-authentication-card-logo />
            </div>

            <div class="w-full sm:max-w-2xl mt-6 p-6 bg-white shadow-md overflow-hidden sm:rounded-lg prose">
                {!! $policy !!}
            </div>
        </div>
    </div>
</x-guest-layout>

resources/views/settings.blade.php
@section('styles')
<link rel="stylesheet" href="{{asset('/css/app.css')}}">
@endsection

<x-app-layout title="Settings" active="settings">
    <div class="content h-full  z-0">
        <div class="container-fluid flex flex-col  mb-10">
                @if (Laravel\Fortify\Features::canUpdateProfileInformation())
                @livewire('profile.update-profile-information-form')

                <x-jet-section-border />
                @endif

                @if (Laravel\Fortify\Features::enabled(Laravel\Fortify\Features::updatePasswords()))
                <div class="mt-10 sm:mt-0">
                    @livewire('profile.update-password-form')
                </div>

                <x-jet-section-border />
                @endif

                @if (Laravel\Fortify\Features::canManageTwoFactorAuthentication())
                <div class="mt-10 sm:mt-0">
                    @livewire('profile.two-factor-authentication-form')
                </div>

                <x-jet-section-border />
                @endif

                <div class="mt-10 sm:mt-0">
                    @livewire('profile.logout-other-browser-sessions-form')
                </div>
    </div>
</div>

   
</x-app-layout>

resources/views/terms.blade.php
<x-guest-layout>
    <div class="pt-4 bg-gray-100">
        <div class="min-h-screen flex flex-col items-center pt-6 sm:pt-0">
            <div>
                <x-jet-authentication-card-logo />
            </div>

            <div class="w-full sm:max-w-2xl mt-6 p-6 bg-white shadow-md overflow-hidden sm:rounded-lg prose">
                {!! $terms !!}
            </div>
        </div>
    </div>
</x-guest-layout>

resources/views/user/create.blade.php
<x-app-layout title="Create User" active="create-user">
    <section class="content">
        <div class="container-fluid">
            <div class="row">
                <div class="col-md-12">
                    <div class="card card-primary">
                        <div class="card-header bg-pink">
                            <h3 class="card-title">User Information</h3>
                        </div>
                        <form method="POST" action="{{ route('ovp_panel.dashboard.users.store') }}">
                            @csrf
                            <div class="card-body">
                                <div class="form-group">
                                    <label for="name">Name</label>
                                    <input name="name" type="text" class="form-control" id="name"
                                        placeholder="Enter name">
                                </div>
                                @error('name')
                                <div class="alert alert-danger">{{ $message }}</div>
                                @enderror
                                <div class="form-group">
                                    <label for="email">Email</label>
                                    <input name="email" type="email" class="form-control" id="email"
                                        placeholder="Enter email">
                                </div>
                                @error('email')
                                <div class="alert alert-danger">{{ $message }}</div>
                                @enderror

                                @php
                                $hashed_random_password = randomPassword();
                                @endphp


                                <div class="form-group">
                                    <label for="password">Password</label>
                                    <div class="input-group">
                                        <div class="custom-file">
                                            <input name="password" type="password" class="form-control"
                                                id="password-input" placeholder="Password">
                                        </div>
                                        <div class="input-group-append">
                                            <span onclick="generatePassword()"
                                                class="pointer input-group-text">Generate</span>
                                            <span onclick="toggleShowPassword()" id="show-password-btn"
                                                class="pointer input-group-text">Show</span>
                                        </div>
                                    </div>
                                </div>

                                @error('password')
                                <div class="alert alert-danger">{{ $message }}</div>
                                @enderror


                            </div>
                            <div class="card-footer">
                                <button type="submit" class="btn btn-default ">Submit</button>
                            </div>
                        </form>
                    </div>


                </div>

            </div>
        </div>
    </section>
</x-app-layout>

resources/views/user/edit.blade.php
<x-app-layout title="Edit User" active="edit-user">
    <section class="content">
        <div class="container-fluid">
            <div class="row">
                <div class="col-md-12">
                    <div class="card card-primary">
                        <div class="card-header bg-pink">
                            <h3 class="card-title">User Information</h3>
                        </div>
                        <form method="POST" action="{{ route('ovp_panel.dashboard.users.update',['user'=>$user->id]) }}">
                            @csrf
                            @method('PATCH')
                            <div class="card-body">
                                <div class="form-group">
                                    <label for="name">Name</label>
                                    <input value="{{$user->name}}" name="name" type="text" class="form-control"
                                        id="name" placeholder="Enter name">
                                </div>
                                @error('name')
                                <div class="alert alert-danger">{{ $message }}</div>
                                @enderror
                                <div class="form-group">
                                    <label for="email">Email</label>
                                    <input value="{{$user->email}}" name="email" type="email" class="form-control"
                                        id="email" placeholder="Enter email">
                                </div>
                                @error('email')
                                <div class="alert alert-danger">{{ $message }}</div>
                                @enderror

                                <div class="form-group">
                                    <label for="password">New Password</label>
                                    <div class="input-group">
                                        <div class="custom-file">
                                            <input name="password" type="password" class="form-control"
                                                id="password-input" placeholder="Password">
                                        </div>
                                        <div class="input-group-append">
                                            <span onclick="generatePassword()"
                                                class="pointer input-group-text">Generate</span>
                                            <span onclick="toggleShowPassword()" id="show-password-btn"
                                                class="pointer input-group-text">Show</span>
                                        </div>
                                    </div>
                                </div>
                                @error('password')
                                <div class="alert alert-danger">{{ $message }}</div>
                                @enderror
                            </div>
                            <div class="card-footer">
                                <button type="submit" class="btn btn-default ">Submit</button>
                            </div>
                        </form>
                    </div>


                </div>

            </div>
        </div>
    </section>
</x-app-layout>

resources/views/user/index.blade.php
<x-app-layout title="Manage Users" active="view-users">
    <section class="content">
        <div class="container-fluid">
            <div class="row">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header bg-pink">
                            <h3 class="card-title">Users</h3>
                        </div>

                        <div class="card-body table-responsive p-0">
                            <table class="table table-hover text-nowrap">
                                <thead>
                                    <tr>
                                        <th>ID</th>
                                        <th>User</th>
                                        <th>Date Created</th>
                                        <th>Email</th>
                                        <th>Edit</th>
                                        <th>Delete</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    @foreach($users as $user)
                                    <tr>
                                        <td>{{$user->id}}</td>
                                        <td>{{$user->name}}</td>
                                        <td>{{$user->created_at}}</td>
                                        <td>{{$user->email}}</td>
                                        <td><a href="{{ route('ovp_panel.dashboard.users.edit',['user'=>$user->id]) }}"
                                                class="badge bg-pink">Edit</a></td>
                                        <td>

                                            <form
                                                action="{{ route('ovp_panel.dashboard.users.destroy',['user'=>$user->id]) }}"
                                                method="POST">
                                                @csrf
                                                @method('DELETE')
                                                <button type="submit" class="border-0 badge bg-danger">Delete</button>
                                        </td>
                                        </form>
                                    </tr>
                                    @endforeach
                                </tbody>
                            </table>
                        </div>

                    </div>

                </div>
            </div>
        </div>
    </section>
</x-app-layout>